better support for systems with no pxe
[automated-distro-installer] / faiserver-setup
index 617a3dc04d80c50fbd5168aa2b72c2da18012cc5..e43d0192f79eed094432471a95f52da8bb5c5dd5 100755 (executable)
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
+# Usage: faiserver-setup
+#
 # Initial setup of a fai server on debian. works on localhost.
 # Set's the current ip as the tftp server. I vaguely remember
-# that using a hostname does not work
-# Requires changing dns to point faiserver and running fai-redep
+# that using a hostname does not work.
+# Separate from running this, faiserver needs to be setup in dns
+# to point to whatever host this is run on.
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
@@ -26,14 +29,28 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 [[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
 
 e() { echo "$@"; "$@"; }
+
+# tried with stretch at one point, but jessie works for everything,
+# so no point in changing it. Leaving some code to deal with
+# stretch hanging around as it will eventually become stable.
+base=jessie
+sed="sed -ri --follow-symlinks"
+
+
+if [[ $base == jessie ]]; then
+    wget -O - http://fai-project.org/download/074BCDE4.asc | apt-key add -
+    cat >/etc/apt/sources.list.d/fai.list <<'EOF'
+deb http://fai-project.org/download jessie koeln
+EOF
+else
+    # if we use stretch, no need for fai-project repo.
+    rm -f /etc/apt/sources.list.d/fai.list
+fi
+
 # for ubuntu:
 #add-apt-repository -y ppa:fai/ppa
 
 # for debian:
-wget -O - http://fai-project.org/download/074BCDE4.asc | apt-key add -
-cat >/etc/apt/sources.list.d/fai.list <<'EOF'
-deb http://fai-project.org/download jessie koeln
-EOF
 
 apt-get update
 # all the dependencies except the dhcp server
@@ -43,31 +60,44 @@ to_install=()
 for pkg in $deps; do
     dpkg -s $pkg &>/dev/null && continue ||:
     to_install+=($pkg)
-    echo $pkg >>/etc/fai/fai-manually-installed-packages
+    # just so we have a record.
+    echo `date` $pkg >>/var/log/fai-manually-installed-packages.log
 done
 if [[ $to_install ]]; then
     apt-get -y install ${to_install[@]}
 fi
 
-sed="sed -ri --follow-symlinks"
-$sed 's/^#deb/deb/' /etc/fai/apt/sources.list
+r=http://http.us.debian.org/debian
+# like default, but scrap httpredir and add suggested newer pkgs in fai-project.org
+dd of=/etc/fai/apt/sources.list <<EOF
+deb $r $base main contrib non-free
+deb http://security.debian.org/debian-security $base/updates main contrib non-free
+EOF
+
+if [[ $base == jessie ]]; then
+    tee -a /etc/fai/apt/sources.list <<'EOF'
+deb http://fai-project.org/download jessie koeln
+EOF
+fi
+
+# tried out a stretch base, doesn't work yet.
+$sed -f - /etc/fai/nfsroot.conf <<EOF
+s,^( *FAI_DEBOOTSTRAP=).*,\1"$base $r",
+EOF
+
 $sed 's/#LOGUSER/LOGUSER/' /etc/fai/fai.conf
 # from man fai-make-nfsroot,
 # figured out after partitioning ignored my crypt partition
+
+
 if ! grep cryptsetup /etc/fai/NFSROOT &>/dev/null; then
     $sed '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
 fi
-fai-setup -vf
+fai-setup -vf
 { head -n 1 /srv/fai/nfsroot/root/.ssh/known_hosts | awk '{print $1}' \
-        | tr '\n' ' '; ssh-keyscan localhost | grep -o "ecdsa-sha2-nistp256.*"; \
+      | tr '\n' ' '; ssh-keyscan localhost | grep -o "ecdsa-sha2-nistp256.*"; \
     } >>/srv/fai/nfsroot/root/.ssh/known_hosts
 
-# this does not alter the config on a new install
-$sed 's#^([[:space:]]*TFTP_DIRECTORY[[:space:]]*=).*#\1"/srv/tftp"#' \
-    /etc/default/tftpd-hpa
-
-service tftpd-hpa restart
-
 # initially did the basic fai-chboot -Iv $std_arg default
 # but found in console that it wanted to mount nfsroot
 # to be the same as my dhcp server.
@@ -78,17 +108,6 @@ service tftpd-hpa restart
 
 # Add debug to -f flag for more verbose output.
 
-std_arg="-u nfs://faiserver/srv/fai/config"
-e fai-chboot -Iv $std_arg default # reset so we are idempotent
-kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
-type -t host &>/dev/null || apt-get -y install dnsutils
-# resolve host using gateway address
-my_ip=$(host faiserver $(route -n | sed -rn 's/^(0\.){3}0\s+(\S+).*/\2/p') | \
-               sed -rn 's/^\S+ has address //p')
-k_args=$(fai-chboot -L '^default$' | \
-                sed -r "s/^(\S+\s+){3}(.*root=)(.*)/\2$my_ip:\3/")
-e fai-chboot -k "$k_args" -v -f verbose,sshd,createvt,reboot $std_arg $kernel default
-
 # make the faiserver also the apt proxy server
 apt-get -y install apt-cacher-ng